unit Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants, IOUtils,
  FMX.Types, FMX.Graphics, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.StdCtrls,
  FMX.ScrollBox, FMX.Memo, FMX.Controls.Presentation, IPPeerClient,
  IPPeerServer, System.Tether.Manager, System.Tether.AppProfile,
  Tethering, FMX.Layouts, FMX.ListBox;

type
  TMainForm = class(TForm)
    Header: TToolBar;
    Footer: TToolBar;
    HeaderLabel: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListBox1: TListBox;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
    TethSpr: TTetheringSpravce;
    SL: TStringList;

    procedure ResourceReceived(const Sender: TObject;
      const AResource: TRemoteResource);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.fmx}

procedure TMainForm.Button1Click(Sender: TObject);
begin
  TethSpr.NajdiZarizeni; // defaultne trva 5 vtein
end;

procedure TMainForm.Button2Click(Sender: TObject);
var
  cesta: string;
begin
  cesta := TPath.GetPublicPath + '/ciselniky.s3db';
  TethSpr.PosliSoubor('ciselniky.s3db', cesta, 'PC');
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  TethSpr.Pripoj('PC');
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  TethSpr.PosliText('Popisek', 'Ahoj svte', 'PC');
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  SL := TStringList.Create;
  TethSpr := TTetheringSpravce.VytvorSpravce('Mobil', 'tpro', ListBox1);
  TethSpr.MyTetheringAppProfile.OnResourceReceived := ResourceReceived;
end;

procedure TMainForm.ResourceReceived(const Sender: TObject;
  const AResource: TRemoteResource);
var
  fs: TFileStream;
  ms: TMemoryStream;
begin
  if AResource.ResType = TRemoteResourceType.Data then // text
  begin
    ListBox1.Items.Add(AResource.Hint + ' ; ' + AResource.Value.AsString);
  end;

  if AResource.ResType = TRemoteResourceType.Stream then // soubor
  begin
    fs := TFileStream.Create('D:\' + AResource.Hint, fmCreate);
    try
      ms := TMemoryStream.Create;
      ms := TMemoryStream(AResource.Value.AsStream);
      ms.Position := 0;
      ms.SaveToStream(fs);
    finally
      freeandnil(fs);
    end;
  end;

end;

end.
